{-- Algebras - Interface between TerraLib and Haskell

    (c) Sergio Costa (INPE) - Setembro, 2005

	This program is free software; you can redistribute it 
    and/or modify it under the terms of the GNU General 
    Public License 2.1 as published by the Free Software Foundation
    (http://www.opensource.org/licenses/gpl-license.php)
--}

{--  --}


module TerraHS.Algebras.Base
	(
		

	
		Ids (..), ObjectId (..),
	
		Set (..) , BinaryPredicates (..),
		
		--, Relations (..),
	
				-- * The Object Module class
		Pointer (..), Convert (..), Element (..), Size (..)	,

		
		-- * The @Value@ type 
		Value (..),
			
		-- * The @Attribute@ type 
		Attribute (..),
			
		-- * The @Values@ class
		Values (..),
			
		-- * The @Attributes@ class
		Attributes (..), getValuebyName

	)
	 where



import TerraHS.Algebras.Base.Ids
import TerraHS.Algebras.Base.Attribute 
import TerraHS.Algebras.Base.Operations

import TerraHS.Algebras.Base.Object